//ESTEBAN CALCAGNO
//TRABAJO FINAL - Curso Posgrado Matematica Aplicada a el Arte Diagital I
//Profesor Andrès Colubri
//Año 2009

//Clase 4 - Ejercicio G 
//Escribir un programa para pintar los píxeles interiores 
//a un triángulo arbitrario utilizando la función point().

//Declaro las variables correspondientes a las coordenadas 
//de los tres puntos del triangulo arbitrario
int X0, Y0, X1, Y1, X2, Y2;
  
//Establezco las características de la ventana
void setup()
{
  //Ventana de 400X400
  size(400,400);
  //Suavizo los graficos
  smooth();

    background(255);
  
  //Declaro el valor de las coordenadas X e Y de los puntos
  //del triangulo
  X0 = 200;
  Y0 = 150;
  
  X1 = 150;
  Y1 = 250;
  
  X2 = 250;
  Y2 = 250;
  
  //Dibujo el triangulo arbitrario de color blanco con
  //las coordenadas antes declaradas
  strokeWeight(1);
  fill(255);
  triangle(X0, Y0, X1, Y1, X2, Y2);
  
}

//Loop Principal
void draw()
{
  //Establezco fondo blanco para la ventana

  //Dibujo los tres puntos antes declarados
  //(tres elipses)
  strokeWeight(10);
  fill(255,0,0);
  ellipse(X0, Y0, 5, 5);
  fill(0,255,0);
  ellipse(X1, Y1,5,5);
  fill(0,0,255);
  ellipse(X2, Y2,5,5);

//////////////////////////////////////////////////////////
  //Declaro las variables para el cálculo de las ecuaciones 
  //generales de las tres rectas que conforman el triangulo 
  float EcuacionGeneral01;
  float EcuacionGeneral12;
  float EcuacionGeneral20;
  int Dx01, Dx12,Dx20;
  int Dy01, Dy12,Dy20;
  
  
  for(int x=0; x<=width; x++)
  {
      for(int y=0; y <= height; y++)
      {
      
  //Cálculo la ecuacion de la recta que pasa por los puntos 0 y 1
  //Recta 0-1
  
  //Delta X y Delta Y
  Dx01 = X0 - X1;
  Dy01 = Y0 - Y1;
  
  EcuacionGeneral01 = Dy01*x + (-Dx01)*y + (Dx01*Y0 - Dy01*X0);
  
  //Cálculo la ecuacion de la recta que pasa por los puntos 1 y 2
  //Recta 1-2
  
  //Delta X y Delta Y
  Dx12 = X2 - X1;
  Dy12 = Y2 - Y1;
  
  EcuacionGeneral12 = Dy12*x + (-Dx12)*y + (Dx12*Y1 - Dy12*X1);
  
  //Cálculo la ecuacion de la recta que pasa por los puntos 2 y 0  
  //Recta 2-0
  
  //Delta X y Delta Y
  Dx20 = X2 - X0;
  Dy20 = Y2 - Y0;
  
  EcuacionGeneral20 = Dy20*x + (- Dx20)*y + (Dx20*Y2 - Dy20*X2);
 
  //Si se dan las siguientes posibilidades significa que el mouse
  //esta dentro del triangulo
  
  
        if(EcuacionGeneral01 <0 && EcuacionGeneral12>0 && EcuacionGeneral20 < 0)
            {
                //Pinto los pixeles de adentro del triangulo arbitrario   
                strokeWeight(3);
                point(x, y);
            }
      } 
}   
}

//FIN
