// Mariano Cura.

import processing.opengl.*;

circulo [] circulos;

class circulo {
  float x, y, ancho, alto, vel, ang, despX;
  int colR, colG, colB;

  void dibujar (){
    fill((colR * cos(ang))+10, (colG * tan(ang)) + 10, ((colB * sin(ang)) + 10));
    ellipse (despX, y+sin(ang)*alto, ancho, alto); 
  }

  void mover () {
    ang += vel;
    despX = despX+1;
    if (despX == width + 40) despX = 0;
  }
}


void setup (){
  size (600, 400, OPENGL);
  circulos = new circulo [80];
  for (int i = 0; i < circulos.length; i ++){
    circulos [i]       = new circulo ();
    circulos [i].x     = random(0,(width));
    circulos [i].y     = random(0,(height));
    circulos [i].ancho = random(10,40);
    circulos [i].alto  = random(10,40);
    circulos [i].ang   = random(0,360);
    circulos [i].vel   = random(-0.5, 0.5);
    circulos [i].colR   = int(random(0, 255));
    circulos [i].colG   = int(random(0, 255));
    circulos [i].colB   = int(random(0, 255));
  }
}

void draw () {
  for (int i = 0; i < circulos.length; i++) {
    circulos [i].dibujar();
    circulos [i].mover();
  }
}



