// Rotacion centrada en el centro de la pantalla.
float[][] R;

void setup()
{
  size(400, 400);
  smooth();

  R = new float[2][2];
}

void draw()
{

  // aca compara la posicon anterior del mouse 
  // para pintar solo si esta se pasa el mouse

  if (mouseX != pmouseX)
  {

    float x0, y0, x1, y1;

    fill(255, 10);
    rect(100,200 ,0, 0);



    float angulo = map(mouseX, 0, width, 0,PI);

    R[0][0] = cos(angulo);
    R[0][1] = sin(angulo);
    R[1][0] = -sin(angulo);
    R[1][1] = cos(angulo);

    for (int y = -2 * height; y < 2 * height; y = y + 50)
    { 


      x0 = R[0][0] * (-2 * width - 0.5 * width) + R[0][1] * (y - 0.5 * height) + 0.5 * width;
      y0 = R[1][0] * (-2 * width - 0.5 * width) + R[1][1] * (y - 0.5 * height) + 0.5 * height;

      x1 = R[0][0] * (2 * width - 0.5 * width) + R[0][1] * (y - 0.5 * height) + 0.5 * width;
      y1 = R[1][0] * (2 * width - 0.5 * width) + R[1][1] * (y - 0.5 * height) + 0.5 * height;

      stroke(30, 60, 100,10);
      line(x0, y0, 100,100); 

      stroke(195, 100, 0,10);
      line(x0, y0, 300, 300); 

      stroke(245, 100, 100,10);
      line(50, 50, x1, y1); 

      stroke(255, 0, 0,10);
      line(x0, y0, 150,250); 

      stroke(10, 100, 0,10);
      line(250,100, x1,y1); 

      stroke(145, 190, 0,10);
      line(x0, y0,350,350); 

      stroke(5, 100, 140,10);
      line(x0, y0, 10,10); 

      stroke(100, 0, 100,10);
      line(x0, y0, 390,50); 

      stroke(100, 0, 100,10);
      line(100,200,x1,y1); 

      stroke(255,255,0 ,10);
      line(x0, y0, 200,200); 
    }
  }
}


