// Mariano Cura.

// Ejemplo de sistema de particulas.
// Estos dos arreglos se usan para guardar las coordenadas
// x e y de las particulas.
float[] x;
float[] y;
float[] a;
float[] b;
// Estos dos arreglos se usan para guardar las velocidades
// vx y vy de las particulas.
float[] vx;
float[] vy;
float[] vz;
color[] col;
void setup()
{
  size(400, 400, P3D);
  // Se crean loa arreglos para guardar 100 particulas:
  x = new float[400];
  y = new float[400];
  vx = new float[400];
  vy = new float[400];
  a = new float[400];
  b = new float[400];
  col = new color[400];
  // Se asignan posiciones iniciales y velocidades aleatorias.
  for (int i = 0; i < 400; i++)
  {
    x[i] = random(0, width);
    y[i] = random(0, height);
    vx[i] = random(-1, 1);
    vy[i] = random(-1, 1);
    a[i] = random(2, 20);
    b[i] = random(2, 20);

    col[i] = color( random(0,255), random(0,255), random(0,255), random(150,200));
  }
}
void draw()
{
  fill(0, 30);
  rect(0, 0, width, height);
  // En este bucle se actualizan las posiciones de cada particula
  // dependiendo de su velocidad.
  for (int i = 0; i < 400; i++)
  {
    // Se actualiza la coordenada x.
    x[i] = x[i] + vx[i];
    if (width < x[i])
    {
      // Si la particula se sale de la pantalla por la
      // derecha vuelve a entrar por la izquierda.
      x[i] = 0;
    }
    if (x[i] < 0)
    {
      // Si la particula se sale de la pantalla por la
      // izquierda vuelve a entrar por la derecha.
      x[i] = width;
    }
    y[i] = y[i] + vy[i];
    if (height < y[i])
    {
      // Si la particula se salen de la pantalla por la
      // abajo vuelve a entrar por la arriba.
      y[i] = 0;
    }
    if (y[i] < 0)
    {
      // Si la particula se salen de la pantalla por la
      // arriba vuelve a entrar por la abajo.
      y[i] = height;
    }
    
    
    // Se dibuja la particula.
    noStroke ();
    fill (col[i]);
    ellipse(x[i], y[i], a[i], b[i]);
  }
}

