// Ejemplo de sistema de particulas. 
// Estos dos arreglos se usan para guardar las coordenadas  
// x e y de las particulas. 
float[] x; 
float[] y; 
// Estos dos arreglos se usan para guardar las velocidades 
// vx y vy de las particulas. 
float[] vx; 
float[] vy;
float[] diry;

int [] r;
int [] g;
int [] b;

float angulo;

int cantidad;

int radio;

void setup() 
{ 
  size(400, 400);
  smooth();

  radio = 10; 
  
  // Se crean loa arreglos para guardar 100 particulas: 
  cantidad = 100;
  
  x = new float[cantidad];   
  y = new float[cantidad];  
  vx = new float[cantidad];   
  vy = new float[cantidad];  
  diry = new float[cantidad];

  r = new int [cantidad];
  g = new int [cantidad];
  b = new int [cantidad];

  // Se asignan posiciones iniciales y velocidades aleatorias. 
  for (int i = 0; i < cantidad; i++) 
  { 
    x[i] = random(0, width);   
    y[i] = random(0, height); 

    vx[i] = random(-1, 1);
    vy[i] = random(-1, 1);  
    if (random(0, 1) < 0.5)
    {
      diry[i] = +1;
    }
    else
    {
      diry[i] = -1;      
    }
    
    r[i] = int (random(0, 255));
    g[i] = int (random(0, 255));
    b[i] = int (random(0, 255));  
  } 
} 
void draw() 
{
  //background(0);
  fill(255, 10);
  rect(0, 0, width, height);
  
  // En este bucle se actualizan las posiciones de cada particula 
  // dependiendo de su velocidad. 
  for (int i = 0; i < cantidad; i++) 
  { 
    // Se actualiza la coordenada x.
    x[i] = x[i] + vx[i]; 
    //x[i] = x[i] + (sin (angulo) * 0.2); 
    
    if (width < x[i]) 
    { 
      // Si la particula se sale de la pantalla por la  
      // derecha vuelve a entrar por la izquierda. 
      x[i] = 0; 
    } 
    if (x[i] < 0) 
    { 
      // Si la particula se sale de la pantalla por la  
      // izquierda vuelve a entrar por la derecha. 
      x[i] = width; 
    } 

    //y[i] = y[i] + vy[i]; 
 
    y[i] = y[i] + diry[i] * (sin (angulo) * 1.2); 
    
    if (height < y[i]) 
    { 
      // Si la particula se salen de la pantalla por la  
      // abajo vuelve a entrar por la arriba. 
      y[i] = 0; 
    } 
    if (y[i] < 0) 
    { 
      // Si la particula se salen de la pantalla por la  
      // arriba vuelve a entrar por la abajo. 
      y[i] = height; 
    }         

    // Se dibuja la particula.
    //stroke(r[i], g[i], b[i]);
    noStroke();
    fill(r[i], g[i], b[i]);
    ellipse(x[i], y[i], radio, radio); 
    
    angulo += 0.5;

  } 
} 





